﻿/**
 * @author manager
 */
var form;
var serverpath = "http://dep805.ru/jqt/";//"http://server/";//
var mediapath = serverpath+"demo/";
var rendererpath = serverpath+"../../cgi-bin/mimetex/";//serverpath+"cgi-bin/";//
$(function(){
	form = $('form#test');
	$(window).resize(function(){
		$('#content').center();
	});
	if (air) {
		$.ajaxSetup({
			type: "POST",
			url: serverpath+"demoindex.php5",
			dataType: "json",
			error: ajaxError
		});
	} else {
		$.ajaxSetup({
			url: serverpath+"demoindex.php5",
			dataType: "jsonp",
			jsonp: "callback",
			error: ajaxError
		});
	}
	formContent();
});
function formContent(){
	$('#content').hide();
	form.el('img','',{src:'icons/AIRApp_48.png',width:48,height:48,alt:'Jqt',title:'Jqt'});
	form.el('h1','',{id:'header'});
	form.el('div','',{id:'form_content','class':'fcontent'});
	var div = form.el('div','',{id:'bottom'});
	div.el('div','',{'class':'holder'}).el('input','',{type:'button',name:'submitbutton',id:'submitbutton'}).click(function(){form.submit();});
	div.el('div','',{id:'error'});
	div.el('div','',{id:'message'}).hide().addClass('grey');
	div.el('div','',{id:'hint'});
	showMode('auth');
	$('#content').fadeIn('slow');
}
function ajaxError(req,status,error){
	$('#error').html('Сбой связи с сервером!<br/>Текст ошибки: '+(status||'')+(error||'')+'.').show();
	$('#submitbutton').show();
	$('#message').hide();
}
var messages = {
	login:'Логин не зарегистрирован!',
	password:'Пароль введён неверно!',
	exists:'Введенный логин уже был зарегистрирован! Попробуйте зарегистрировать другой.',
	empty:'Заполните поле "%field%"!',
	tooshort:'В&nbsp;поле "%field%" должно быть хотя&nbsp;бы %number%&nbsp;символов!',
	connection:'Невозможно установить соединение с сервером!',
	selection:'Невозможно установить соединение с базой данных!',
	querying:'Невозможно получить данные из базы!',
	insertion:'Невозможно вставить данные в базу!',
	unauthorized:'Вы не авторизованы!'
};
function validate(field){
	if (field.val()=='') {
		showError(field.attr('id'), messages['empty'].replace(/%field%/,$.grep(fields,function(f){
			return (f.id == field.attr('id'));
		})[0].text));
		return false;
	};
	if (field.val().length<parseInt(field.attr('minlength'))) {
		showError(field.attr('id'), messages['tooshort'].replace(/%field%/,$.grep(fields,function(f){
			return (f.id == field.attr('id'));
		})[0].text).replace(/%number%/,field.attr('minlength')));
		return false;
	}
	return true;
}
function showError(field,msg){
	if (field.length&&document.getElementById(field)){
		$('#error').html(msg).show();
		$('#'+field).focus().select();
		$('#'+field).keydown(function(){$('#error').hide();$('#submitbutton').parent().show();})
	} else {
		$('#error').html(msg).show().fadeTo(1000,1).slideUp(1500);
		$('#submitbutton').parent().show();
	}
}
var db = {};
function select(r){
	$('#message').hide();
	if (r.error) {
		showError(r.error,messages[r.error]);
	} else {
		db.subjects=r.subjects;
		db.tests=r.tests;
		$('#message').html(modes[mode].header+' прошла успешно!').removeClass('grey').addClass('light-green').show()
		.fadeTo(1000,1).slideUp('slow',function(){$(this).removeClass('light-green').addClass('grey')});
		showMode('select');
	};
};
function question(q){
	if (q.error) {
		$('#message').hide();
		showError('',messages[q.error]);
	} else {
		//debug(q);
		if (q.settings.finish) {
			$('#message').hide();
			$('#submitbutton').parent().show();
			showMode('mark');
			var div = $('#form_content').removeClass('qcontent').addClass('fcontent');
			if (q.settings.complete) {
				div.el('h1','Тест пройден!',{'class':'light-green'});
				div.el('h2','Вам выставлена отметка: '+q.settings.mark);
			} else {
				div.el('h2','Вы досрочно остановили процесс тестирования!',{'class':'orange'});
				div.el('h2','Отметка не выставлена.');
			}
			if (q.settings.results) {
				var res = q.settings.results;
				$('#form_content').removeClass('fcontent').addClass('qcontent');
				$('#form_content').el('h2', 'Ваши ответы:', {'class': 'orange'});
				for (var i = 0; i < res.length; i++) {
					$('#form_content').el('h2', 'Задание ' + (i + 1), {'class': 'light-green'});
					db.question = {
						elements: JSON.parse(res[i].question),
						answer: JSON.parse(res[i].answer),
						right_answer: JSON.parse(res[i].right_answer)
					}
					$.each(db.question.elements, element);
					$('#form_content').el('div', 'Правильность ответа: ' + res[i].raw_grade + '%', {'class': 'grade'});
				}
			}
		} else if (q.settings.complete){
			$('#message').hide();
			$('#submitbutton').parent().show();
			showMode('mark');
			var div = $('#form_content').removeClass('qcontent').addClass('fcontent');
			var dansw = q.settings.d;
			if ((dansw%10<5) && (dansw%10>1) && !((dansw%100<15)&&(dansw%100>11))) {
				dansw += "&nbsp;дополнительных вопроса";
			} else if ((dansw%10 == 1) && (dansw%100!=11)) {
				dansw += "&nbsp;дополнительный вопрос";
			} else {
				dansw += "&nbsp;дополнительных вопросов";
			}
			var additionText = 'Вы можете повысить отметку, правильно ответив на&nbsp;'+dansw+
				'.<br/>В&nbsp;случае неправильных ответов вы&nbsp;можете получить отметку&nbsp;'+
				q.settings.markdown+'.';
			div.el('div',additionText,{'class':'addition'}).prependTo(div);
			div.el('h2','Вам выставлена отметка: '+q.settings.mark).prependTo(div);
			$('#addition').parent().show();
			var atime = parseInt(q.settings.answer_time);
			if (atime) {
				var t = $('#form_content').el('span','',{'class': 'timer'}).prependTo(div)
					.timer(atime,function(){form.submit();});
				t.start();
				form.submit(t.stop);
				$('#hint a').click(t.stop);
				$('#addition').click(t.stop);
			}
		} else {
			showMode('test');
			$('#form_content').removeClass('fcontent').addClass('qcontent');
			db.use_help = (q.settings.use_help=='1');
			db.help_used = false;
			db.question = false;
			var atime = parseInt(q.settings.answer_time);
			if (atime) {
				var t = $('#form_content').el('span','',{'class': 'timer'}).timer(atime,function(){form.submit();});
				t.start();
				form.submit(t.stop);
				$('#hint a').click(t.stop);
			}
			$('#form_content').el('h1','Задание ',{'class':'light-green'})
			.el('span','('+q.settings.n+' из '+q.settings.min_questions+')',{'class':'qcount'});
			$.each(q.elements,element);
			$('#message').hide();
			$('#submitbutton').parent().show();
			$(':input').eq(0).focus();
		}
	}
	addBrowserCSS();
	$('#content').center();
};
function element(i,e){
	if ((e!=null) && ('content' in e) && ('type' in e)){
		types[e.type]($('.qcontent'),e.content,db.question);
	}
};
function getID(el){
	var a = $(el).attr('id').split('_');
	a[0] = '';
	return a;
};
function debug(data){
	air?air.trace(JSON.stringify(data)):alert(JSON.stringify(data));
};
